
#include "mysqlcppapi/Allocator_Connection.h"
#include <iostream>


namespace mysqlcppapi
{


Allocator_Connection::cpointer Allocator_Connection::allocate()
{
  cpointer pcobj = Allocator_Zeroed<MYSQL>::allocate(); //simple new with zeroed memory.
 
  ::mysql_init(pcobj); //TODO: error handling?

  return pcobj;
}

void Allocator_Connection::deallocate(cpointer pInstance, bool do2ndStageDeallocation)
{
  if(do2ndStageDeallocation)
  {
    ::mysql_close(pInstance); //TODO: error handling?
  }
 
  Allocator_Zeroed<MYSQL>::deallocate(pInstance, do2ndStageDeallocation /* this parameter is not used */); //simple delete.
  
}


} //namespace
