#include "mysqlcppapi/datetime/date_base.h"

namespace mysqlcppapi
{

std::ostream& date_base::out_stream (std::ostream& s) const
{
  char fill = s.fill('0');
  std::ios::fmtflags flags = s.setf(std::ios::right);
  s << std::setw(4) << year << '-' 
    << std::setw(2) << month << '-'
    << std::setw(2) << day;
  s.flags(flags);
  s.fill(fill);
  return s;
}

std::string::size_type date_base::convert (const std::string& str)
{
  std::string::size_type i = 0;

  std::string strYear = str.substr(i, 4);
  year = strtol(strYear.c_str(), 0, 10);
  i += 4;
  
  if (str.at(i) == '-') i++;
  
  std::string strMonth = str.substr(i, 2);
  month = strtol(strMonth.c_str(), 0, 10);
  i += 2;
  
  if (str.at(i) == '-') i++;
  
  std::string strDay = str.substr(i, 2);
  day = strtol(strDay.c_str(), 0, 10);
  i += strDay.size();
  
  return i;
}

short int date_base::compare(const date_base* other) const
{
  if (year != other->year)
    return year - other->year;

  if (month != other->month)
    return month - other->month;

  return day - other->day;
}


} //namespace
