#include "mysqlcppapi/datetime/time_base.h"

namespace mysqlcppapi
{

time_base::time_base()
{
}

time_base::~time_base()
{
}

std::ostream& time_base::out_stream(std::ostream& s) const
{
  char fill = s.fill('0');
  std::ios::fmtflags flags = s.setf(std::ios::right);
  s << std::setw(2) << hour << ':' 
    << std::setw(2) << minute << ':'
    << std::setw(2) << second;
  s.flags(flags);
  s.fill(fill);
  return s;
}

std::string::size_type time_base::convert(const std::string& str)
{
  std::string::size_type i = 0;

  std::string strHour = str.substr(i, 2);
  hour = strtol(strHour.c_str(), 0, 10);
  i += 2;
  
  if (str.at(i) == ':') i++;
  
  std::string strMinute = str.substr(i, 2);
  minute = strtol(strMinute.c_str(), 0, 10);
  i += 2;
  
  if (str.at(i) == ':') i++;
  
  std::string strSecond = str.substr(i, 2);
  second = strtol(strSecond.c_str(), 0, 10);
  i += strSecond.size();
  
  return i;
}

short int time_base::compare(const time_base* other) const
{
  if (hour != other->hour)
    return hour - other->hour;

  if (minute != other->minute)
    return minute - other->minute;

  return minute - other->minute;
}

} //namespace
