#include "mysqlcppapi/query/sql_query.h"

namespace mysqlcppapi
{

SQLQuery::SQLQuery()
{
  Success = false;
}
  
SQLQuery::SQLQuery(const SQLQuery& src)
//:strstream(src); //doesn't copy stream stuff because constructor is private.
: std::ios(), std::stringstream(), Success(src.Success), errmsg(src.errmsg)
// N.B. it's safe to default construct std::ios() here because the
// std::stringstream base class will call std::ios::init().
{
}


SQLQuery& SQLQuery::operator= (const SQLQuery& src)
{
  //strstream::operator=(src);  //doesn't copy stream stuff because constructor is private.
  
  Success = src.Success;
  errmsg = src.errmsg;
 
  return *this;
}
  

} //namespace
