
#include "mysqlcppapi/row/Row.h"
#include "mysqlcppapi/query_results/Result_Store.h"

namespace mysqlcppapi
{

Row::Row()
{
}

Row::Row(MYSQL_ROW d, const Result_Use& result, type_length* jj)
{
  m_sharedptr_result = type_sharedptr_result(new Result_Use(result)); //Deleted after last unreference.
  
  if(d)
  {
    for(size_type i = 0; i < size(); i++)
    {
      std::string strData;
      if(d[i])
        strData = std::string( d[i], jj[i] );

      data.push_back(strData);

      bool bIsNull = (d[i] == NULL);
      is_nulls.push_back(bIsNull);
    }
  }
}

Row::~Row()
{
}	

const Result_Use& Row::parent() const
{
  return *(m_sharedptr_result.obj()); //Shared.
}

Row::size_type Row::size() const
{
  return m_sharedptr_result->num_fields();
}
  
const ColData Row::operator [] (size_type i) const
{
  return ColData( data[i], is_nulls[i] );
}

const ColData Row::operator[] (const std::string& strFieldName) const
{
  const Fields& fields = m_sharedptr_result->get_fields();
  return operator[](fields.get_index(strFieldName));
}

Row::type_vecStrings Row::get_vector() const
{
  type_vecStrings vecResult(size());

  for(size_type i = 0; i < size(); i++)
  {
    const std::string& strField = operator[](i);
    vecResult[i] = strField;
  }

  return vecResult;
}

} //namespace

